// VPK
//=======================================================================================================================

#pragma pack(push, 1)
typedef struct
{
	u32 Signature;
	u32 Version;
	u32 TreeSize;
	u32 FileDataSectionSize;
	u32 ArchiveMD5SectionSize;
	u32 OtherMD5SectionSize;
	u32 SignatureSectionSize;
} 
VPKHeader;

typedef struct
{
	u32 CRC;
	u16 PreloadBytes; 
	u16 ArchiveIndex;
	u32 EntryOffset;
	u32 EntryLength;
	u16 Terminator;
} 
VPKDirectoryEntry;
#pragma pack(pop)

void vpk_free( VPKHeader *self )
{
	free( self );
}

VPKDirectoryEntry *vpk_find( VPKHeader *self, const char *asset )
{
	if( !self ) 
		return NULL;
	
	char wbuf[ 512 ];
	strcpy( wbuf, asset );
	
	char *ext = csr_findext( wbuf, '.' );
	*(ext-1) = 0x00;
	char *fn = csr_findext( wbuf, '/' );
	*(fn-1) = 0x00;
	char *dir = wbuf;
	
	char *pCur = ((char *)self) + sizeof( VPKHeader );
	
	while( 1 )
	{
		if( !*pCur ) break;

		int bExt = !strcmp( ext, pCur );		
		
		while( *( pCur ++ ) ) {};
		while( 1 )
		{
			if( !*pCur ) { pCur ++; break; }

			int bDir = !strcmp( dir, pCur );

			while( *( pCur ++ ) ) {};
			while( 1 )
			{
				if( !*pCur ) { pCur ++; break; }
			
				const char *vpk_fn = pCur;
			
				while( *( pCur ++ ) ) {};
				VPKDirectoryEntry *entry = (VPKDirectoryEntry *)pCur;
				
				if( !strcmp( vpk_fn, fn ) && bExt && bDir ) 
				{
					return entry;
				}
				
				pCur += entry->PreloadBytes + sizeof( VPKDirectoryEntry );
			}
			
			if( bDir && bExt ) return NULL;
		}
		
		if( bExt ) return NULL;
	}
	
	return NULL;
}
